#include <string.h>
#include <stdio.h>
#include "ubloxAgnssAidIni.h"

/************************************************************
ƣisLeapYear
ܣжϡжϹһ򣬰겻İ
룺yearж
1, ꣬0꣨ƽ꣩
************************************************************/
int isLeapYear(int year)
{	
	if ((year & 0x3) != 0)
	{						// year4ıһƽ
		return 0;
	}	
	else if ((year % 400) == 0)
	{						// year400ı
		return 1;
	}	
	else if ((year % 100) == 0)
	{						// year100ı
		return 0;
	}	
	else
	{						// year4ı
		return 1;
	}
}
/*************************************************************************
ƣ	gregorian2SvTime
ܣ	ʱʽת, ҪUTC
			ʱʽǳʱʽʱ䣻
			תʱʽGPSʱʽʱʾGPSʱ1980.1.6
			GPSʱûʱ䣬ʱǾ
			2016ֵ17
룺	pDateTime,	ṹָ룬ʱʽʱ
	aidwn,	GPSaidtowGPSʱ
*************************************************************************/
void gregorian2SvTime(DATETIME_STR *pDateTime, unsigned short *aidwn, double *aidtow)
{	
	int DayMonthTable[12] = {31,28,31,30,31,30,31,31,30,31,30,31};
	int i, dn, wn;
	double tod, tow;

	// ʱ
	tod = pDateTime->hour * 3600 + pDateTime->minute * 60 + pDateTime->second + pDateTime->ms / 1000.0;
	dn  = pDateTime->day;
#ifdef UTC_BEIJING_TIME
	tod = tod - 3600*8;
	if (tod < 0)
	{
		tod += 86400;
		dn 	-= 1;
	}
#endif	
	// οʱ: 1980.1.6
	// ->
	for (i = 1980; i < (pDateTime->year); i++)
	{
		if (isLeapYear(i))
		{
			dn += 366;
		}			
		else
		{
			dn += 365;
		}
	}
	dn -= 6;
	// ->
	if (isLeapYear(pDateTime->year))
	{
		DayMonthTable[1] = 29;
	}		
	for (i = 1; i < pDateTime->month; i++)
	{
		dn += DayMonthTable[i-1];
	}		

	// +ʱ
	wn	= (dn / 7);						// 
	tow = (dn % 7) * 86400 + tod + 17;	// ʱ䣬

	if (tow >= 604800)
	{
		wn++;
		tow -= 604800;
	}

	*aidwn 	= wn;
	*aidtow = tow;
}

/*************************************************************************
ƣubloxAgnssAidIni
ܣѸλú͸ʱרõݸʽϢʽ
룺dateTimeʱ䣬Ч־1Ч
		  lla, γȱ־Ч־1Ч
aidIniMsg[54]ַ飬Ϣݰȹ̶
*************************************************************************/
void ubloxAgnssAidIni(DATETIME_STR dateTime, POS_LLA_STR lla, char aidIniMsg[56])
{
	UBLOX_AID_INI_STR aidIni;
	double	ubxtow;
	int cka, ckb, i;

	gregorian2SvTime(&dateTime, &aidIni.wnoOrDate, &ubxtow);
	
	aidIni.towOrTime		= (unsigned int)(ubxtow * 1000 + 0.5);
	aidIni.xOrLat			= (int)(lla.lat * 1e7);
	aidIni.yOrLon			= (int)(lla.lon * 1e7);
	aidIni.zOrAlt			= (int)(lla.alt * 100);
	aidIni.posAcc			= 0;
	aidIni.tmCfg			= 0;
	aidIni.towNs			= 0;
	aidIni.tAccMs			= 0;
	aidIni.tAccNs			= 0;
	aidIni.clkDOrFreq		= 0;
	aidIni.clkDAccOrFreqAcc	= 0;
	
	aidIni.flags 		= 0x20;											// λøʽLLAʽ߶ЧƵʺλþȹЧ
	aidIni.flags 		= aidIni.flags | ((lla.valid 	  == 1) << 0); 	// BIT0λЧ־
	aidIni.flags 		= aidIni.flags | ((dateTime.valid == 1) << 1); 	// BIT1ʱЧ־
	// ͷļװ
	aidIniMsg[0]  = 0xB5;
	aidIniMsg[1]  = 0x62;
	aidIniMsg[2]  = 0x0B;		// LENGTH
	aidIniMsg[3]  = 0x01;
	aidIniMsg[4]  = 0x30;		// CLASS	ID
	aidIniMsg[5]  = 0x00;		// MESSAGE	ID
	// ݴ
	memcpy(&aidIniMsg[6],  (char*)(&aidIni), 48);
	// У
	cka = ckb = 0;
	// غɼУ
	for (i = 2; i < 54; i++)
	{
		cka = cka + aidIniMsg[i];
		ckb = ckb + cka;
	}
	// У
	aidIniMsg[54] = cka;
	aidIniMsg[55] = ckb;
	
	return;
}
